#!/usr/bin/perl -U
# Description: MailGates Upgrade Script
# Copyright (C)2007 Openfind Information Technology ,Inc. All rights reserved.

use IO::File;
use Fcntl qw/:flock/;

######################################################################
#
# GLOBAL VARIABLE
#
######################################################################
$PATCHID = "4.2.1_012";
$MG_CTL = "/mailgates/mg/bin/mg_ctl.pl";
$RESTARTSHM = "/mailgates/tools/restartshm";
$RELOADINI = "/mailgates/tools/reloadini";
$FCL_ADMIN = "/mailgates/mg/util/fcl_admin";
$ETC_DIR = '/etc';
$RC_LOCAL_FILE = '/rc.d/rc.local';
$MG_HEAD = 'mg';
$LN = '/bin/ln';
$MV = '/bin/mv';
$CRONBIN = "crontab";
$IPCRM = "ipcrm";
$SHMKEY1 = 213456;
$SHMKEY2 = 891234;
$SEMKEY = 189977518;
$gDebug = 0;
$TMP_FILE = "/mailgates/mg/tmp/upt.tmp";
$MG_STAT_DIR = "/mailgates/mg/run/log.metadata";
$LOG2QLOG_PID_FILE = "/mailgates/mg/qlogs/log2qlog.pid";
$JOBLIST_MGR_PID_FILE = "/mailgates/mg/run/mg_audit_joblist_mgr.pid";
$g_VirusAction = undef;

######################################################################
#
# ERROR CODE
#
######################################################################

######################################################################
#
# Utility
#
######################################################################
sub GetPid
{
	my $file = shift;
	my $pid = -1;
	if (defined($file) && -e $file) {
		if (!open(IN, "<$file")) {
			logit("open $file failed($!)");
			return $pid;
		}
		$pid = <IN>;
		chomp($pid);
		$pid += 0;
		close(IN);
	}
	return $pid;
}

sub BeforeProcess {
	# stop cron
	$cmd = "/etc/init.d/crond stop";
	$< = 0;
	system($cmd);
	$< = $UID;

	# stop deamon all
	print "Stop all\n";
	$cmd = "$MG_CTL -q stop all";
	perlsu($UID, $cmd);

}

sub AfterProcess {
	# create symlink
	if (!-f "/mailgates/lib/libiconv.so.2") {
		if (!symlink ("/mailgates/lib/libiconv.so.2.5", "/mailgates/lib/libiconv.so.2")) {
			system("cp -p /mailgates/lib/libiconv.so.2.5 /mailgates/lib/libiconv.so.2");
		}
	}

	# restart all deamons
	print "Restart all deamons... \n";
	$cmd = "$MG_CTL -q start all";
	perlsu($UID, $cmd);

	# start crond
	print "Start crond... ";
	$cmd = "/etc/init.d/crond start";
	$< = 0;
	system($cmd);
	$< = $UID;
	print "Done.";

}

1;
